#line 1 "C:/_MikroC/_MesProjets_MikroC/_12F1840_GT38_test_Transceivers_2024_11/_12F1840_GT38_test_Transceivers_2024_11.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 100 "C:/_MikroC/_MesProjets_MikroC/_12F1840_GT38_test_Transceivers_2024_11/_12F1840_GT38_test_Transceivers_2024_11.c"
sbit GT38_Set_Pin at LATA.B1;
sbit GT38_Set_Pin_Dir at TRISA.B1;
#line 116 "C:/_MikroC/_MesProjets_MikroC/_12F1840_GT38_test_Transceivers_2024_11/_12F1840_GT38_test_Transceivers_2024_11.c"
sbit Relay at LATA.B0;
sbit Relay_Dir at TRISA.B0;




const code char mesg0[]="                    ";
const code char mesg1[]=" Compilateur : " "MikroC 7.6.0" "\n\r";
const code char mesg2[]=" Directory :" "C:\\_MikroC\\_MesProjets_MikroC\\_12F1840_GT38_test_Transceivers_2024_11" "\r\n";
const code char mesg3[]=" Projet    :" "_12F1840_GT38_test_Transceivers_2024_11.mcppi" "\r\n";
const code char mesg4[]=" Source    :" "_12F1840_GT38_test_Transceivers_" "_" "2024_11" "\r\n";
const code char mesg5[]=" MCU  :" "12F1840 DIP8" " , Config: " "P12F1840_Fosc_Interne_16MHz.cfgsch" "\r\n";
const code char mesg6[]=" Alim.: " "3,6V  4.5V" "\r\n ATTENTION! Pin 1 =VDD pin 8=Gnd\r\n";
const code char mesg7[]=" Capteur OWS DS18B20 sur RA2(pin5) \r\n GT38 SET sur RA1(pin6)\r\n";
const code char mesg8[]=" GT38 mode" "FU4" "\r\n Canal : " "C016" "\r\n UART1 <-> GT38 " "B1200" ",8,N,1 pin2=RA5=RX  Pin3=RA4=Tx\r\n";




const code char mesg9[]=" Avec sortie Relay sur RA0 (Pin 7), pas de UART3 !\r\n";

const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9};




volatile char buffer1[ 40 ];
unsigned short error;
volatile unsigned int CptErr;
volatile unsigned int Count;
volatile int Flag_Timer1;
volatile int DataReady1;
volatile int NB;
volatile int Index1, i1;
volatile unsigned char c1, cx;
volatile int j;
unsigned int i,k;

char *p1;
char TEXTE[40];
char *txt;
char CRam1[16];
unsigned int Mode_Sleep;
char Recu=0;

volatile unsigned int Count1;

unsigned int temp=0;
#line 175 "C:/_MikroC/_MesProjets_MikroC/_12F1840_GT38_test_Transceivers_2024_11/_12F1840_GT38_test_Transceivers_2024_11.c"
void strConstRamCpy(char *dest, const char *source);
void Write_String(char * texte);
void CRLF1(void);
void Tempo(unsigned long L);
void Arme_Timer1(unsigned int N);
char DS18B20_Build_value(unsigned int temp2write, char * T);
#line 267 "C:/_MikroC/_MesProjets_MikroC/_12F1840_GT38_test_Transceivers_2024_11/_12F1840_GT38_test_Transceivers_2024_11.c"
void Interrupts() iv 0x0004 ics ICS_AUTO
{
 if ( (RCIE_bit==1) && (PIR1.RCIF==1) )
 {
 c1 = RCREG;
 if (RCSTA.OERR==1)
 {
 RCSTA.CREN = 0 ;
 c1 = RCREG;
 RCSTA.CREN = 1 ;
 CptErr++;
 }
 if(RCSTA.FERR==1 )
 {
 RCSTA.SPEN = 0 ;
 CptErr++;
 RCSTA.SPEN= 1 ;
 c1 = RCREG;
 }


 if ((Flag_Timer1==1) || (i1> 40 -2) || (c1==13) )
 {
 RCIE_bit=0 ;
 buffer1[i1]=0;
 DataReady1=1;
 Index1=i1;
 Delay_ms(20);
 c1=RCREG;
 i1=0;
 c1=0;
 }
 else
 {
 buffer1[i1]=c1;
 Index1=i1;
 i1++;
 }

 }

 if ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
 {
 Count1--;

 if (Count1<1)
 {
 Count1=0;
 Flag_Timer1=1;
 TMR1IE_bit=0;
 }
 TMR1H = 0x3C;
 TMR1L = 0xB0;
 PIR1.TMR1IF=0;

 }


 }


void Write_String(char * texte)
{
while ((* texte)>0)
 {
 UART1_Write(* texte++);
 }
}


void strConstRamCpy(char *dest, const char *source) {
 while(*source) *dest++ = *source++ ;
 *dest = 0 ;
}

void CRLF1()
{
 UART_Write( 13 );
 UART_Write( 10 );
}

void UART1_Write_CText(const char *txt1) {
 while ((*txt1)>0)
 UART1_Write(*txt1++);

}

void Raz_Buffer1()
{
 RCSTA.CREN = 0 ;
 CptErr=0;
 if(RCIF_bit==1) c1=RCREG;
 DataReady1=0;

 for(i1=0;i1< 40 -2;i1++) buffer1[i1]=0;
 i1=0;
 Index1=0;
 c1=0;
 Flag_Timer1=0;

 RCSTA.CREN = 1 ;
 RCIE_bit = 1;
 p1=0;

}

void Arme_Timer1(unsigned int N)
 {


 T1CON = 0x30;
 TMR1H = 0x3C;
 TMR1L = 0xB0;
 T1GCON=0;
 Count1=N;
 Flag_Timer1=0;
 PIR1.TMR1IF=0;
 PIE1.TMR1IE=1;
 TMR1ON_bit=1;
}


char DS18B20_Build_value(unsigned int temp2write, char * T)
 {
 const unsigned int RES_SHIFT =4;
 unsigned char temp_whole;
 unsigned int temp_fraction;
 char Signe=0;


 if (temp2write & 0x8000) {
 Signe=1 ;
 *(T) = '-';
 temp2write = ~temp2write + 1;
 }
 else
 {
 Signe=0;
 *(T) = '+';
 }

 temp_whole = temp2write >> RES_SHIFT ;

 *(T+1) = (temp_whole/10)%10 + 48;
 if (*(T+1)=='0') *(T+1)=' ';
 *(T+2)= temp_whole%10 + 48;

 temp_fraction = temp2write << (4-RES_SHIFT);
 temp_fraction &= 0x000F;
 temp_fraction *= 625;
 *(T+3)='.';

 *(T+4) = temp_fraction/1000 + 48;
 *(T+5) = (temp_fraction/100)%10 + 48;
 return Signe ;
 }



void main()
{


 OSCCON=0b01111010;







 WDTCON =0b00011010;
 Delay_ms(500);

 TRISA=0b10100100;
 ANSELA=0;
 WPUA=0b00110000;
 WPUA=0b00110000;




 _asm NOP ;

 APFCON=0;
 APFCON.P1BSEL=1;
 _asm NOP ;
 APFCON.RXDTSEL=1;
 _asm NOP ;
 APFCON.TXCKSEL=1;
 _asm NOP ;
 Delay_ms(100);

 CM1CON0=0;
 CM1CON1=0;
 CCP1CON=0;



 TRISA=0b10101100;










 Relay_Dir=0;
 Relay=0;

 GT38_Set_Pin_Dir=0;
 GT38_Set_Pin=1;

 FVRCON.FVREN=0;
 FVRCON.TSEN=0;
 FVRCON.CDAFVR1=0;
 ADCON0=0;
 ADCON1=0x00;


 txt=&TEXTE[0];
 UART1_Init(9600);


 TRISA=0b11101100;


 if (PIR1.RCIF==1) c1 = RCREG;
 if (PIR1.RCIF==1) c1 = RCREG;
 DataReady1=0;
 Index1=0;
#line 513 "C:/_MikroC/_MesProjets_MikroC/_12F1840_GT38_test_Transceivers_2024_11/_12F1840_GT38_test_Transceivers_2024_11.c"
 Count=0;
 CptErr=0;
 c1=0;
 NB=64;
 txt =&TEXTE[0];

 RCSTA=0;
 RCSTA.CREN=1;
 RCSTA.SPEN=1;
 RCSTA.SREN=1;
 c1 = RCREG;

 INTCON=0;
 OPTION_REG=0;

 GT38_Set_Pin=0;
 Delay_ms(300);
 TMR1IE_bit=1;
 RCIE_bit=1;
 INTCON.PEIE=1;
 INTCON.GIE=1;

 NB=30;
 Arme_Timer1(20);
 Raz_Buffer1();
 UART1_Write_CText("AT\r\n");
 while( (Flag_Timer1==0) & (DataReady1==0) );


 Raz_Buffer1();
 Arme_Timer1(20);
 UART1_Write_CText("AT+V\r\n");
 while( (Flag_Timer1==0) & (DataReady1==0) );


 Raz_Buffer1();
 Arme_Timer1(20);
 UART1_Write_CText("AT+" "C016" "\r\n");
 while( (Flag_Timer1==0) & (DataReady1==0) );


 Raz_Buffer1();
 Arme_Timer1(20);
 UART1_Write_CText("AT+" "FU4" "\r\n");
 while( (Flag_Timer1==0) & (DataReady1==0) );
#line 577 "C:/_MikroC/_MesProjets_MikroC/_12F1840_GT38_test_Transceivers_2024_11/_12F1840_GT38_test_Transceivers_2024_11.c"
 Raz_Buffer1();
 Arme_Timer1(20);
 UART1_Write_CText("AT\r\n");
 while( (Flag_Timer1==0) & (DataReady1==0) );

 Raz_Buffer1();
 Arme_Timer1(20);
 UART1_Write_CText("AT+RX\r\n");
 while( (Flag_Timer1==0) & (DataReady1==0) );

 Delay_ms(100);
 GT38_Set_Pin=1;
 Delay_ms(100);
 DataReady1=0;
 RCIE_bit=0;
 Delay_1sec();
 j=0;
 Ow_Reset( &PORTA,2 );
 Delay_us(250);
 Ow_Write( &PORTA,2 , 0x33);
 Delay_us(250);
 c1=Ow_Read( &PORTA,2 );
 Delay_us(250);

 txt=&TEXTE[0];
 *(txt)=0;
 ByteToHex(c1,txt);
 for (i=0;i<6;i++)
 {
 c1= Ow_Read( &PORTA,2 );
 Delay_us(250);

 *(txt)=0;
 ByteToHex(c1,txt);
 }


 RCSTA=0;
 RCSTA.CREN=0;
 RCSTA.SPEN=0;
 RCIE_bit=0;
 c1 = RCREG;

 UART1_Init(1200);
 RCSTA.CREN=1;
 RCSTA.SPEN=1;
 c1 = RCREG;


 TRISA=0b10101100;

 j=0;
 k=0;
 txt=&TEXTE[0];
 *(txt)=0;
 Mode_Sleep=0;
 NB=32;
 RCIE_bit=1;

 while(1)
 {
 j++;

 Ow_Reset( &PORTA,2 );
 Delay_us(50);
 Ow_Write( &PORTA,2 , 0xCC);
 Delay_us(50);
 Ow_Write( &PORTA,2 , 0x44);
 Delay_us(250);
 Ow_Reset( &PORTA,2 );
 Ow_Write( &PORTA,2 , 0xCC);
 Ow_Write( &PORTA,2 , 0xBE);

 temp = Ow_Read( &PORTA,2 );
 temp = (Ow_Read( &PORTA,2 ) << 8) + temp;
 for (i=0;i<32;i++) TEXTE[i]=0;
 txt=&TEXTE[0];

 WordToStr(j, txt) ;
#line 659 "C:/_MikroC/_MesProjets_MikroC/_12F1840_GT38_test_Transceivers_2024_11/_12F1840_GT38_test_Transceivers_2024_11.c"
 k=strlen(txt);
 strConstRamCpy(txt+k,"; Text=+19.99C\r\n");
 cx= DS18B20_Build_value(temp,txt+k+7) ;
#line 665 "C:/_MikroC/_MesProjets_MikroC/_12F1840_GT38_test_Transceivers_2024_11/_12F1840_GT38_test_Transceivers_2024_11.c"
 UART1_Write_Text(txt) ;
 Raz_Buffer1();
 Arme_Timer1(20);
 while ((Flag_Timer1==0)&& (DataReady1==0));
 if(DataReady1==1)
 {




 p1=strstr(buffer1,"Relay=");
 if(p1>0)
 {
 if(*(buffer1+6)=='1')
 {
 UART1_Write_CText("Realy ON\r\n") ;
 Relay=0;
 }
 else
 {
 UART1_Write_CText("Realy OFF\r\n") ;
 Relay=1;
 }
 }

 p1=0;
 DataReady1=0;

 }
 else
 {
 Delay_1sec();
 Delay_1sec();
 }



 }
 }
